import { RedBlackTreeEntry, RedBlackTreeStructure } from '../internals';
export interface DiffTracer<K, V = null> {
    added?(entry: RedBlackTreeEntry<K, V>): boolean | void;
    removed?(entry: RedBlackTreeEntry<K, V>): boolean | void;
    retained?(before: RedBlackTreeEntry<K, V>, after: RedBlackTreeEntry<K, V>): boolean | void;
}
export declare function diff<T extends DiffTracer<K, V>, K, V = null>(trace: T, before: RedBlackTreeStructure<K, V>, after: RedBlackTreeStructure<K, V>): T;
