"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@collectable/core");
const first_1 = require("./first");
/**
 * Retrieves the value of the first entry in the tree, or undefined if the tree is empty.
 *
 * @export
 * @template K The type of keys in the tree
 * @template V The type of values in the tree
 * @param {RedBlackTreeStructure<K, V>} tree The input tree
 * @returns {(K|undefined)} The value of the first entry in the tree, or undefined if the tree is empty
 */
function firstValue(tree) {
    var node = first_1.first(tree);
    return core_1.isDefined(node) ? node.value : void 0;
}
exports.firstValue = firstValue;
//# sourceMappingURL=firstValue.js.map