import { RedBlackTreeStructure } from '../internals';
/**
 * Retrieves the last key in the tree.
 *
 * @export
 * @template K The type of keys in the tree
 * @template V The type of values in the tree
 * @param {RedBlackTreeStructure<K, V>} tree The input tree
 * @returns {([K, V]|undefined)} The key of the last entry in the tree, or undefined if the tree was empty
 */
export declare function lastKey<K, V = null>(tree: RedBlackTreeStructure<K, V>): K | undefined;
