"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ops_1 = require("./ops");
const node_1 = require("./node");
const path_1 = require("./path");
function rebalance(tail, node, parent, tree) {
    var p = tail;
    var done = false;
    do {
        parent = p.node;
        if (done) {
            ops_1.updateCount(parent);
        }
        else if (parent._red) {
            var pp = p.parent, grandParent = pp.node;
            var uncle = pp.next === 1 /* LEFT */ ? node_1.editRightChild(tree, grandParent) : node_1.editLeftChild(tree, grandParent);
            if (uncle._red) {
                uncle._red = false;
                parent._red = false;
                if (pp.parent.isActive()) {
                    grandParent._red = true;
                }
                ops_1.updateCount(parent);
                ops_1.updateCount(grandParent);
                node = grandParent;
            }
            else {
                if (pp.next === p.next) {
                    if (p.next === 1 /* LEFT */) {
                        ops_1.rotateRight(pp.parent, grandParent, parent, tree);
                    }
                    else {
                        ops_1.rotateLeft(pp.parent, grandParent, parent, tree);
                    }
                    grandParent._red = true;
                    parent._red = false;
                    node = parent;
                }
                else {
                    if (p.next === 1 /* LEFT */) {
                        ops_1.rotateRightLeft(pp.parent, grandParent, parent, node, tree);
                    }
                    else {
                        ops_1.rotateLeftRight(pp.parent, grandParent, parent, node, tree);
                    }
                    node._red = false;
                    grandParent._red = true;
                }
            }
            p = p.release();
            if (!node._red) {
                done = true;
            }
        }
        else {
            done = parent === p.node;
            node = parent;
            ops_1.updateCount(node);
        }
        p = p.release();
    } while (p.isActive());
    if (p.isActive()) {
        node = path_1.PathNode.release(p, node);
    }
}
exports.rebalance = rebalance;
//# sourceMappingURL=rebalance.js.map