import * as C from '@collectable/core';
import { createTree, isRedBlackTree } from '../internals';
import { iterateKeysFromFirst } from './iterateKeysFromFirst';
import { set } from './set';
export function fromKeys(compare, keys, mutability) {
    const tree = C.modify(createTree(compare, mutability));
    if (Array.isArray(keys)) {
        for (var i = 0; i < keys.length; i++) {
            set(keys[i], null, tree);
        }
    }
    else {
        const it = isRedBlackTree(keys) ? iterateKeysFromFirst(keys) : keys[Symbol.iterator]();
        var current;
        while (!(current = it.next()).done) {
            set(current.value, null, tree);
        }
    }
    return C.commit(tree);
}
//# sourceMappingURL=fromKeys.js.map