import * as C from '@collectable/core';
import { isUndefined, stringCompare } from '@collectable/core';
import { createTree } from '../internals';
import { set } from './set';
export function fromObject(obj, compare, mutability) {
    if (C.isMutationContext(compare)) {
        mutability = compare;
        compare = void 0;
    }
    if (isUndefined(compare)) {
        compare = stringCompare;
    }
    const tree = C.modify(createTree(compare, mutability));
    const keys = Object.keys(obj);
    for (var i = 0; i < keys.length; i++) {
        var key = keys[i];
        set(key, obj[key], tree);
    }
    return C.commit(tree);
}
//# sourceMappingURL=fromObject.js.map