import { RedBlackTreeStructure } from '../internals';
/**
 * Retrieves the value associated with the specified key
 *
 * @export
 * @template K The type of keys in the tree
 * @template V The type of values in the tree
 * @param {K} key The key of the entry to retrieve
 * @param {RedBlackTreeStructure<K, V>} tree The input tree
 * @returns {(V|undefined)} The value associated with the specified key, or undefined if the key does not exist in the tree
 */
export declare function get<K, V = null>(key: K, tree: RedBlackTreeStructure<K, V>): V | undefined;
