import { RedBlackTreeStructure } from '../internals';
/**
 * Determines whether or not a given key exists in the tree
 *
 * @export
 * @template K The type of keys in the tree
 * @template V The type of values in the tree
 * @param {K} key The key to look for
 * @param {RedBlackTreeStructure<K, V>} tree The input tree
 * @returns {boolean} True if the there is an entry for the specified key, otherwise false
 */
export declare function has<K, V = null>(key: K, tree: RedBlackTreeStructure<K, V>): boolean;
