import * as C from '@collectable/core';
export class Node {
    constructor(mctx, key, value, _red, _left, _right, _count) {
        this.key = key;
        this.value = value;
        this._red = _red;
        this._left = _left;
        this._right = _right;
        this._count = _count;
        this['@@mctx'] = mctx;
    }
    /** @internal */
    '@@clone'(mctx) {
        return new Node(mctx, this.key, this.value, this._red, this._left, this._right, this._count);
    }
}
const anyVoid = void 0;
export const NONE = new Node(C.immutable(), anyVoid, anyVoid, false, anyVoid, anyVoid, 0);
NONE._left = NONE;
NONE._right = NONE;
export function createNode(tree, red, key, value) {
    return new Node(C.getSubordinateContext(tree), key, value, red, NONE, NONE, 1);
}
export function isNone(node) {
    return node === NONE;
}
export function editRightChild(owner, node) {
    var child = node._right;
    return isNone(child) || C.areContextsRelated(child, owner) ? child
        : (node._right = (child = C.modifyAsSubordinate(owner, child)), child);
}
export function editLeftChild(owner, node) {
    var child = node._left;
    return isNone(child) || C.areContextsRelated(child, owner) ? child
        : (node._left = (child = C.modifyAsSubordinate(owner, child)), child);
}
export function assignValue(value, node) {
    const v = node.value;
    // Note the double-equals below is used to correctly compare Symbol() with Object(Symbol())
    if (v === value || (v !== null && typeof v === 'object' && v == value)) {
        return false;
    }
    node.value = value;
    return true;
}
//# sourceMappingURL=node.js.map