import { isNone } from './node';
function writeBack(upper, lower, tree) {
    if (upper.isActive()) {
        setChild(upper.next, upper.node, lower);
    }
    else {
        tree._root = lower;
    }
}
export function rotateLeft(upper, parent, child, tree) {
    parent._right = child._left;
    child._left = parent;
    updateCount(parent);
    updateCount(child);
    writeBack(upper, child, tree);
    return child;
}
export function rotateRight(upper, parent, child, tree) {
    parent._left = child._right;
    child._right = parent;
    updateCount(parent);
    updateCount(child);
    writeBack(upper, child, tree);
    return child;
}
export function rotateLeftRight(upper, grandParent, parent, child, tree) {
    parent._right = child._left;
    child._left = parent;
    grandParent._left = child._right;
    child._right = grandParent;
    updateCount(grandParent);
    updateCount(parent);
    updateCount(child);
    writeBack(upper, child, tree);
    return child;
}
export function rotateRightLeft(upper, grandParent, parent, child, tree) {
    parent._left = child._right;
    child._right = parent;
    grandParent._right = child._left;
    child._left = grandParent;
    updateCount(grandParent);
    updateCount(parent);
    updateCount(child);
    writeBack(upper, child, tree);
    return child;
}
export function swapNodeContents(upper, lower) {
    var key = upper.key;
    var value = upper.value;
    upper.key = lower.key;
    upper.value = lower.value;
    lower.key = key;
    lower.value = value;
}
export function swapNodeColors(upper, lower) {
    var red = upper._red;
    upper._red = lower._red;
    lower._red = red;
}
export function setChild(branch, parent, child) {
    if (branch === 0 /* NONE */)
        return;
    if (branch === 1 /* LEFT */) {
        parent._left = child;
    }
    else {
        parent._right = child;
    }
    updateCount(parent);
}
export function updateCount(node) {
    if (isNone(node))
        return;
    node._count = node._left._count + node._right._count + 1;
}
//# sourceMappingURL=ops.js.map